export interface Delegate<THandler> {
    contextEntered?(context: THandler, route: MatchDSL<THandler>): void;
    willAddRoute?(context: THandler | undefined, route: THandler): THandler;
}
export interface Route<THandler> {
    path: string;
    handler: THandler;
    queryParams?: string[];
}
export interface RouteRecognizer<THandler> {
    delegate: Delegate<THandler> | undefined;
    add(routes: Route<THandler>[]): void;
}
export declare type MatchCallback<THandler> = (match: MatchDSL<THandler>) => void;
export interface MatchDSL<THandler> {
    (path: string): ToDSL<THandler>;
    (path: string, callback: MatchCallback<THandler>): void;
}
export interface ToDSL<THandler> {
    to(name: THandler, callback?: MatchCallback<THandler>): void;
}
export declare class Matcher<THandler> {
    routes: {
        [path: string]: THandler | undefined;
    };
    children: {
        [path: string]: Matcher<THandler> | undefined;
    };
    target: THandler | undefined;
    constructor(target?: THandler);
    add(path: string, target: THandler): void;
    addChild(path: string, target: THandler, callback: MatchCallback<THandler>, delegate: Delegate<THandler> | undefined): void;
}
export default function map<TRouteRecognizer extends RouteRecognizer<THandler>, THandler>(this: TRouteRecognizer, callback: MatchCallback<THandler>, addRouteCallback?: (routeRecognizer: TRouteRecognizer, routes: Route<THandler>[]) => void): void;
